/**
* DevExtreme (renovation/button.p.d.ts)
* Version: 20.2.0 (build 20154-2218)
* Build date: Tue Jun 02 2020
*
* Copyright (c) 2012 - 2020 Developer Express Inc. ALL RIGHTS RESERVED
* Read about DevExtreme licensing here: https://js.devexpress.com/Licensing/
*/
import { Rule } from "../core/options/utils";
import { BaseWidgetProps } from "./utils/base-props.p";
export declare const viewFunction: (viewModel: Button) => any;
export declare type ButtonPropsType = typeof BaseWidgetProps & {
    activeStateEnabled?: boolean;
    hoverStateEnabled?: boolean;
    icon?: string;
    iconPosition?: string;
    onClick?: (e: any) => any;
    onSubmit?: (e: any) => any;
    pressed?: boolean;
    stylingMode?: "outlined" | "text" | "contained";
    render?: any;
    text?: string;
    type?: string;
    useInkRipple?: boolean;
    useSubmitBehavior?: boolean;
    validationGroup?: string;
};
export declare const ButtonProps: ButtonPropsType;
export declare type ButtonRef = {
    focus: () => any;
};
interface Button {
    props: typeof ButtonProps;
    contentRef: any;
    submitInputRef: any;
    inkRippleRef: any;
    widgetRef: any;
    onActive: (event: Event) => any;
    onInactive: (event: Event) => any;
    onWidgetClick: (event: Event) => any;
    onWidgetKeyDown: (event: Event, options: any) => any;
    aria: any;
    cssClasses: string;
    elementAttr: any;
    iconSource: string;
    inkRippleConfig: any;
    restAttributes: any;
}
declare const Button: any;
export default Button;
declare type ButtonOptionRule = Rule<typeof ButtonProps>;
export declare function defaultOptions(rule: ButtonOptionRule): void;
