/**
 * DevExtreme (renovation/preact-wrapper/component.js)
 * Version: 20.2.0 (build 20154-2218)
 * Build date: Tue Jun 02 2020
 *
 * Copyright (c) 2012 - 2020 Developer Express Inc. ALL RIGHTS RESERVED
 * Read about DevExtreme licensing here: https://js.devexpress.com/Licensing/
 */
"use strict";
Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.default = void 0;
var _renderer = require("../../core/renderer");
var _renderer2 = _interopRequireDefault(_renderer);
var _dom_component = require("../../core/dom_component");
var _dom_component2 = _interopRequireDefault(_dom_component);
var _preact = require("preact");
var Preact = _interopRequireWildcard(_preact);
var _string = require("../../core/utils/string");
var _utils = require("../preact-wrapper/utils");
var _hooks = require("preact/hooks");
var _element = require("../../core/element");

function _getRequireWildcardCache() {
    if ("function" !== typeof WeakMap) {
        return null
    }
    var cache = new WeakMap;
    _getRequireWildcardCache = function() {
        return cache
    };
    return cache
}

function _interopRequireWildcard(obj) {
    if (obj && obj.__esModule) {
        return obj
    }
    if (null === obj || "object" !== _typeof(obj) && "function" !== typeof obj) {
        return {
            "default": obj
        }
    }
    var cache = _getRequireWildcardCache();
    if (cache && cache.has(obj)) {
        return cache.get(obj)
    }
    var newObj = {};
    var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor;
    for (var key in obj) {
        if (Object.prototype.hasOwnProperty.call(obj, key)) {
            var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null;
            if (desc && (desc.get || desc.set)) {
                Object.defineProperty(newObj, key, desc)
            } else {
                newObj[key] = obj[key]
            }
        }
    }
    newObj.default = obj;
    if (cache) {
        cache.set(obj, newObj)
    }
    return newObj
}

function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : {
        "default": obj
    }
}

function _typeof(obj) {
    "@babel/helpers - typeof";
    if ("function" === typeof Symbol && "symbol" === typeof Symbol.iterator) {
        _typeof = function(obj) {
            return typeof obj
        }
    } else {
        _typeof = function(obj) {
            return obj && "function" === typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj
        }
    }
    return _typeof(obj)
}

function ownKeys(object, enumerableOnly) {
    var keys = Object.keys(object);
    if (Object.getOwnPropertySymbols) {
        var symbols = Object.getOwnPropertySymbols(object);
        if (enumerableOnly) {
            symbols = symbols.filter(function(sym) {
                return Object.getOwnPropertyDescriptor(object, sym).enumerable
            })
        }
        keys.push.apply(keys, symbols)
    }
    return keys
}

function _objectSpread(target) {
    for (var i = 1; i < arguments.length; i++) {
        var source = null != arguments[i] ? arguments[i] : {};
        if (i % 2) {
            ownKeys(Object(source), true).forEach(function(key) {
                _defineProperty(target, key, source[key])
            })
        } else {
            if (Object.getOwnPropertyDescriptors) {
                Object.defineProperties(target, Object.getOwnPropertyDescriptors(source))
            } else {
                ownKeys(Object(source)).forEach(function(key) {
                    Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key))
                })
            }
        }
    }
    return target
}

function _defineProperty(obj, key, value) {
    if (key in obj) {
        Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
        })
    } else {
        obj[key] = value
    }
    return obj
}

function _classCallCheck(instance, Constructor) {
    if (!(instance instanceof Constructor)) {
        throw new TypeError("Cannot call a class as a function")
    }
}

function _defineProperties(target, props) {
    for (var i = 0; i < props.length; i++) {
        var descriptor = props[i];
        descriptor.enumerable = descriptor.enumerable || false;
        descriptor.configurable = true;
        if ("value" in descriptor) {
            descriptor.writable = true
        }
        Object.defineProperty(target, descriptor.key, descriptor)
    }
}

function _createClass(Constructor, protoProps, staticProps) {
    if (protoProps) {
        _defineProperties(Constructor.prototype, protoProps)
    }
    if (staticProps) {
        _defineProperties(Constructor, staticProps)
    }
    return Constructor
}

function _get(target, property, receiver) {
    if ("undefined" !== typeof Reflect && Reflect.get) {
        _get = Reflect.get
    } else {
        _get = function(target, property, receiver) {
            var base = _superPropBase(target, property);
            if (!base) {
                return
            }
            var desc = Object.getOwnPropertyDescriptor(base, property);
            if (desc.get) {
                return desc.get.call(receiver)
            }
            return desc.value
        }
    }
    return _get(target, property, receiver || target)
}

function _superPropBase(object, property) {
    while (!Object.prototype.hasOwnProperty.call(object, property)) {
        object = _getPrototypeOf(object);
        if (null === object) {
            break
        }
    }
    return object
}

function _inherits(subClass, superClass) {
    if ("function" !== typeof superClass && null !== superClass) {
        throw new TypeError("Super expression must either be null or a function")
    }
    subClass.prototype = Object.create(superClass && superClass.prototype, {
        constructor: {
            value: subClass,
            writable: true,
            configurable: true
        }
    });
    if (superClass) {
        _setPrototypeOf(subClass, superClass)
    }
}

function _setPrototypeOf(o, p) {
    _setPrototypeOf = Object.setPrototypeOf || function(o, p) {
        o.__proto__ = p;
        return o
    };
    return _setPrototypeOf(o, p)
}

function _createSuper(Derived) {
    var hasNativeReflectConstruct = _isNativeReflectConstruct();
    return function() {
        var result, Super = _getPrototypeOf(Derived);
        if (hasNativeReflectConstruct) {
            var NewTarget = _getPrototypeOf(this).constructor;
            result = Reflect.construct(Super, arguments, NewTarget)
        } else {
            result = Super.apply(this, arguments)
        }
        return _possibleConstructorReturn(this, result)
    }
}

function _possibleConstructorReturn(self, call) {
    if (call && ("object" === _typeof(call) || "function" === typeof call)) {
        return call
    }
    return _assertThisInitialized(self)
}

function _assertThisInitialized(self) {
    if (void 0 === self) {
        throw new ReferenceError("this hasn't been initialised - super() hasn't been called")
    }
    return self
}

function _isNativeReflectConstruct() {
    if ("undefined" === typeof Reflect || !Reflect.construct) {
        return false
    }
    if (Reflect.construct.sham) {
        return false
    }
    if ("function" === typeof Proxy) {
        return true
    }
    try {
        Date.prototype.toString.call(Reflect.construct(Date, [], function() {}));
        return true
    } catch (e) {
        return false
    }
}

function _getPrototypeOf(o) {
    _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function(o) {
        return o.__proto__ || Object.getPrototypeOf(o)
    };
    return _getPrototypeOf(o)
}
var TEMPLATE_WRAPPER_CLASS = "dx-template-wrapper";
var PreactWrapper = function(_DOMComponent) {
    _inherits(PreactWrapper, _DOMComponent);
    var _super = _createSuper(PreactWrapper);

    function PreactWrapper() {
        _classCallCheck(this, PreactWrapper);
        return _super.apply(this, arguments)
    }
    _createClass(PreactWrapper, [{
        key: "getInstance",
        value: function() {
            return this
        }
    }, {
        key: "_initMarkup",
        value: function() {
            var isFirstRender = 0 === this.$element().children().length;
            var hasParent = this.$element().parent().length > 0;
            var container = isFirstRender && hasParent ? this.$element().get(0) : void 0;
            Preact.render(Preact.h(this._viewComponent, this.getAllProps(isFirstRender)), this.$element().get(0), container)
        }
    }, {
        key: "_render",
        value: function() {}
    }, {
        key: "getAllProps",
        value: function(isFirstRender) {
            var _this = this;
            var options = _objectSpread({}, this.option());
            var attributes = this.$element()[0].attributes;
            var _this$$element$0$styl = this.$element()[0].style,
                width = _this$$element$0$styl.width,
                height = _this$$element$0$styl.height;
            if (isFirstRender) {
                options.elementAttr = _objectSpread(_objectSpread({}, Object.keys(attributes).reduce(function(a, key) {
                    if (attributes[key].specified) {
                        a[attributes[key].name] = attributes[key].value
                    }
                    return a
                }, {})), options.elementAttr)
            } else {
                if (attributes.id) {
                    options.elementAttr = _objectSpread(_defineProperty({}, attributes.id.name, attributes.id.value), options.elementAttr)
                }
                if (attributes.class) {
                    var customClass = attributes.class.value.split(" ").filter(function(name) {
                        return name.indexOf("dx-") < 0
                    }).join(" ");
                    var classes = options.elementAttr.class ? options.elementAttr.class.concat(customClass) : customClass;
                    options.elementAttr = _objectSpread({
                        "class": classes
                    }, options.elementAttr)
                }
            }
            if (!(0, _string.isEmpty)(width)) {
                options.width = width
            }
            if (!(0, _string.isEmpty)(height)) {
                options.height = height
            }
            if (this.viewRef) {
                options.ref = this.viewRef
            }
            Object.keys(this._actionsMap).forEach(function(name) {
                options[name] = _this._actionsMap[name]
            });
            return this.getProps && this.getProps(options) || options
        }
    }, {
        key: "_getActionConfigs",
        value: function() {
            return {}
        }
    }, {
        key: "_init",
        value: function() {
            var _this2 = this;
            _get(_getPrototypeOf(PreactWrapper.prototype), "_init", this).call(this);
            this._actionsMap = {};
            Object.keys(this._getActionConfigs()).forEach(function(name) {
                return _this2._addAction(name)
            });
            this._initWidget && this._initWidget();
            this._supportedKeys = function() {
                return {}
            }
        }
    }, {
        key: "_addAction",
        value: function(event, action) {
            this._actionsMap[event] = action || this._createActionByOption(event, this._getActionConfigs()[event])
        }
    }, {
        key: "_createViewRef",
        value: function() {
            this.viewRef = Preact.createRef()
        }
    }, {
        key: "_optionChanged",
        value: function(option) {
            var _ref = option || {},
                name = _ref.name;
            if (name && this._getActionConfigs()[name]) {
                this._addAction(name)
            }
            _get(_getPrototypeOf(PreactWrapper.prototype), "_optionChanged", this).call(this, option);
            this._invalidate()
        }
    }, {
        key: "_stateChange",
        value: function(name) {
            var _this3 = this;
            return function(value) {
                return _this3.option(name, value)
            }
        }
    }, {
        key: "_createTemplateComponent",
        value: function(props, templateOption, canBeAnonymous) {
            var _this4 = this;
            if (!templateOption && this.option("_hasAnonymousTemplateContent") && canBeAnonymous) {
                templateOption = this._templateManager.anonymousTemplateName
            }
            if (!templateOption) {
                return
            }
            var template = this._getTemplate(templateOption);
            return function(_ref2) {
                var parentRef = _ref2.parentRef,
                    data = _ref2.data,
                    index = _ref2.index;
                (0, _hooks.useLayoutEffect)(function() {
                    var $parent = (0, _renderer2.default)(parentRef.current);
                    var $children = $parent.contents();
                    var payload = {
                        container: (0, _element.getPublicElement)($parent),
                        model: data,
                        transclude: canBeAnonymous && templateOption === _this4._templateManager.anonymousTemplateName
                    };
                    if (isFinite(index)) {
                        payload.index = index
                    }
                    var $template = (0, _renderer2.default)(template.render(payload));
                    if ($template.hasClass(TEMPLATE_WRAPPER_CLASS)) {
                        $template = (0, _utils.wrapElement)($parent, $template)
                    }
                    var $newChildren = $parent.contents();
                    return function() {
                        (0, _utils.removeDifferentElements)($children, $newChildren)
                    }
                }, Object.keys(props).map(function(key) {
                    return props[key]
                }));
                return Preact.h(Preact.Fragment, null)
            }
        }
    }, {
        key: "_wrapKeyDownHandler",
        value: function(handler) {
            var _this5 = this;
            return function(event, options) {
                var originalEvent = options.originalEvent,
                    keyName = options.keyName,
                    which = options.which;
                var keys = _this5._supportedKeys();
                var func = keys[keyName] || keys[which];
                if (void 0 !== func) {
                    var _handler = func.bind(_this5);
                    var result = _handler(originalEvent, options);
                    if (!result) {
                        event.cancel = true;
                        return event
                    }
                }
                return null === handler || void 0 === handler ? void 0 : handler(event, options)
            }
        }
    }, {
        key: "repaint",
        value: function() {
            this._refresh()
        }
    }, {
        key: "registerKeyHandler",
        value: function(key, handler) {
            var currentKeys = this._supportedKeys();
            this._supportedKeys = function() {
                return _objectSpread(_objectSpread({}, currentKeys), {}, _defineProperty({}, key, handler))
            }
        }
    }, {
        key: "setAria",
        value: function() {
            throw new Error('"setAria" method is deprecated, use "aria" property instead')
        }
    }]);
    return PreactWrapper
}(_dom_component2.default);
exports.default = PreactWrapper;
